#!/usr/bin/env python
# -*- coding: utf-8 -*-

# # Cube multidimensionnel - correction
# 
# Manipulation de tables de mortalités façon OLAP, correction des exercices.

# In[1]:


get_ipython().run_line_magic('matplotlib', 'inline')
import matplotlib.pyplot as plt
plt.style.use('ggplot')
import pyensae
from pyquickhelper.helpgen import NbImage
from jyquickhelper import add_notebook_menu
add_notebook_menu()


# On lit les données puis on recrée un [DataSet](http://xarray.pydata.org/en/stable/data-structures.html#dataset) :

# In[2]:


from actuariat_python.data import table_mortalite_euro_stat 
table_mortalite_euro_stat()
import pandas
df = pandas.read_csv("mortalite.txt", sep="\t", encoding="utf8", low_memory=False)
df2 = df[["annee", "age_num","indicateur","pays","genre","valeur"]].dropna().reset_index(drop=True)
piv = df2.pivot_table(index=["annee", "age_num","pays","genre"],
                columns=["indicateur"],
               values="valeur")
import xarray
ds = xarray.Dataset.from_dataframe(piv)
ds


# ### Exercice 1 : que font les lignes suivantes ?
# 
# Le programme suivant uilise les fonctions [align nad reindex](http://xarray.pydata.org/en/stable/data-structures.html?highlight=assign#transforming-datasets) pour faire une moyenne sur une des dimensions du DataSet (le pays) puis à ajouter une variable *meanp* contenant le résultat.

# In[3]:


ds.assign(LIFEEXP_add = ds.LIFEXP-1)


# In[4]:


meanp = ds.mean(dim="pays")
ds1, ds2 = xarray.align(ds, meanp, join='outer')


# In[5]:


joined = ds1.assign(meanp = ds2["LIFEXP"])


# In[6]:


joined.to_dataframe().head()


# Les valeurs *meanp* sont constantes quelque soient le pays à *annee*, *age_num*, *genre* fixés.

# In[7]:


joined.sel(annee=2000, age_num=59, genre='F')["meanp"]


# In[8]: